unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VclTee.TeeGDIPlus, Vcl.StdCtrls, Vcl.ExtCtrls,
  VCLTee.TeEngine, VCLTee.Series, VCLTee.TeeProcs, VCLTee.Chart, Vcl.ComCtrls;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    Series1: TLineSeries;
    Series2: TLineSeries;
    Memo1: TMemo;
    Series3: TLineSeries;
    Series4: TLineSeries;
    Series6: TLineSeries;
    Image1: TImage;
    Panel1: TPanel;
    Label1: TLabel;
    Label3: TLabel;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit3: TLabeledEdit;
    LabeledEdit4: TLabeledEdit;
    LabeledEdit5: TLabeledEdit;
    Button1: TButton;
    LabeledEdit2: TLabeledEdit;
    Label4: TLabel;
    Label2: TLabel;
    LabeledEdit6: TLabeledEdit;
    Label5: TLabel;
    Series5: TPointSeries;
    Label6: TLabel;
    ScrollBar1: TScrollBar;
    Label7: TLabel;
    ScrollBar2: TScrollBar;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ScrollBar1Scroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure ScrollBar2Scroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure LabeledEdit1Change(Sender: TObject);
    procedure LabeledEdit4Change(Sender: TObject);
  private
    { Private 錾 }
    function datainput: boolean;
    function calc_point_of_intersection: boolean;
    procedure graphDraw;
    function calc_arc: boolean;
    procedure fpoint(x, y, ql, qs, xl : double; var xf, yf: double);
    procedure division;
    procedure focusPoint;
    procedure ImageClear;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses math;

var
  x1, x2          : double;       // ƒ̌_
  y1, y2          : double;
  xc0, yc0        : double;       // _
  xcc, ycc        : double;       // ڐ̌_
  a1, b1, c1      : double;       // 񎟎̒l
  b2, c2          : double;       // ̒l
  alpha, beta     : double;       // _̈ʒuʐόvZp
  alpy, bety      : double;
  CF              : boolean;      // _̗LtO
  Q0              : double;       // ˌpx
  focusY          : double;       // œ_Yʒu
  focusL          : double;       // œ_̋
  ImgF            : boolean;      // Image̍}݂̂̃tO
  sclpos          : double;       // ˌ̒W
  SCF             : Boolean;      // ˌ̒LtO
  STF             : Boolean;      // Button1ɂvZJntO

// ͒l
function TForm1.datainput: boolean;
var
  ch: integer;
  Q, Qmin, Qmax: double;
  Qstr : string;
begin
  result := false;
  SCF := False;                     // ˌ̒LtO
  STF := True;                      // Button1ɂvZJntO
  val(LabeledEdit1.Text, a1, ch);
  if ch <> 0 then begin
    application.MessageBox('1̒lɊԈႢ܂B','',0);
    exit;
  end;
  if a1 = 0 then begin
    application.MessageBox('1̒l̓[ł͂܂B','',0);
    exit;
  end;
  val(LabeledEdit2.Text, b1, ch);
  if ch <> 0 then begin
    application.MessageBox('1̒lɊԈႢ܂B','',0);
    exit;
  end;
  val(LabeledEdit3.Text, c1, ch);
  if ch <> 0 then begin
    application.MessageBox('C1̒lɊԈႢ܂B','',0);
    exit;
  end;
  val(LabeledEdit4.Text, b2, ch);
  if ch <> 0 then begin
    application.MessageBox('2̒lɊԈႢ܂B','',0);
    exit;
  end;
  val(LabeledEdit5.Text, c2, ch);
  if ch <> 0 then begin
    application.MessageBox('C2̒lɊԈႢ܂B','',0);
    exit;
  end;
  val(LabeledEdit6.Text, Q0, ch);
  if ch <> 0 then begin
    application.MessageBox('px̒lɊԈႢ܂B','',0);
    exit;
  end;
  Q := arctan(b2) / pi * 180;
  Qstr := floatTostrF(Q, ffFixed, 5,3);
  Qmin := 0;
  Qmax := 180;
  // vZopx͈͂̐ݒ
  if a1 > 0 then begin
    if Q > 0 then begin
      Qmin := Q;
      Qmax := 180;
    end;
    if Q < 0 then begin
       Qmin := 0;
       Qmax := Q + 180
    end;
  end
  else
  begin
    if Q > 0 then begin
      Qmin := 0;
      Qmax := 180 - Q;
    end;
    if Q < 0 then begin
      Qmin := - Q;
      Qmax := 180;
    end;
  end;
  scrollbar2.Max := round(Qmax - 0.5);
  scrollbar2.Min := round(Qmin + 0.5);
  scrollbar1.Position := 50;
  Qstr := FloatTostrF(Qmin, ffFixed, 4, 1) + '<px<' + FloatTostrF(Qmax, ffFixed, 4, 1)+ '';
  LabeledEdit6.EditLabel.Caption := Qstr;
  if Q0 < Qmin then begin
    application.MessageBox('̊px܂B','',0);
    exit;
  end;
  if Q0 > Qmax then begin
    application.MessageBox('̊px傫܂B','',0);
    exit;
  end;
  if Q0 = 0 then begin
    application.MessageBox('̊px[ł͌vZo܂B','',0);
    exit;
  end;
  if Q0 = 180 then begin
    application.MessageBox('̊pxPWOł͌vZo܂B','',0);
    exit;
  end;
  scrollbar2.Position := round(Q0);
  SCF := True;                          // ˌ̒LtO
  // ɂ͊pxvZppxɕύX
  if a1 < 0 then Q0 := - Q0;
  if a1 > 0 then begin
    if Q0 >   90 then Q0 := Q0 - 180;
  end
  else begin
    if Q0 <= -90 then Q0 := 180 + Q0;
  end;
  result := true;
end;

// ʐρ@ʂ̒xvZ
procedure TForm1.division;
var
  i, n        : integer;
  dx, dx2     : double;
  Xmax, Xmin  : double;
  x0, y0      : double;
  y3          : double;
  L, ls       : double;
  x, y        : double;
begin
  n := 10000;
  dx := (x2 - x1) / n;
  L := 0;
  x0 := x1;
  y0 := x0 * x0 * a1 + x0 * b1 + c1;
  for i := 1 to n do begin
    x := i * dx + x1;
    y := x * x * a1 + x * b1 + c1;
    Xmin := (x - x0);
    Xmax := (y - y0);
    ls := sqrt(Xmin * Xmin + Xmax * Xmax);
    L := L + Ls;
    x0 := x;
    y0 := y;
  end;
  memo1.Lines.Add('ϕ = ' + floatTostr(L));

  dx2 := dx / 2;
  L := 0;
  for i := 0 to n - 1 do begin
    x := i * dx + dx2 + x1;
    y3 := x * b2 + c2;
    y := x * x * a1 + x * b1 + c1 - y3;
    ls := y * dx;
    L := L + Ls;
  end;
  L := abs(L);
  memo1.Lines.Add('ϕʐ= ' + floatTostr(L));
end;

// |`vZ
// EƍɕČvZ
function TForm1.calc_arc: boolean;
var
  L, L1, L2 : double;
  s1, s2    : double;
  a3, b3    : double;
  a4, b4    : double;
begin
  xc0 := -b1 / a1 / 2;                               //  ϋȓ_@_X
  yc0 := xc0 * xc0 * a1 + xc0 * b1 + c1;             //        ϋȓ_@_y
  memo1.Lines.Add('O x,y = ' + floatTostr(xc0) + ', ' + floatTostr(yc0));
  b3 := abs(x1 - xc0) * 2;
  a3 := abs(y1 - yc0);                               // x1̍
  if a3 <> 0 then begin
    s1 := sqrt(b3 * b3 + 16 * a3 * a3);
    L1 := s1 / 2 + b3 * b3 / 8 / a3 * ln((4 * a3 + s1) / b3);
  end
  else L1 := 0;
  b4 := abs(x2 - xc0) * 2;
  a4 := abs(y2 - yc0);                              // x2̍
  if a4 <> 0 then begin
    s2 := sqrt(b4 * b4 + 16 * a4 * a4);
    L2 := s2 / 2 + b4 * b4 / 8 / a4 * ln((4 * a4 + s2) / b4);
  end
  else L2 := 0;
  if (x1 - xc0) * (x2 - xc0) > 0 then L := abs(L2 - L1) / 2
                               else L := (L1 + L2) / 2;
  memo1.Lines.Add('');
  memo1.Lines.Add('|`ʒ =  ' + floatTostr(L));
  result := true;
end;

// |`̖ʐ
// 1/6ŌvZ
function TForm1.calc_point_of_intersection: boolean;
var
  i , n: integer;
  dx              : double;
  Xmax, Xmin      : double;
  x, y            : double;
  a0, b0, c0      : double;
  b3, c3, b4, c4  : double;
  d, e, s         : double;
  ycp             : double;
begin
  result := False;
  a0 := a1;                             // ƒ̌_vZ
  b0 := b1 - b2;
  c0 := c1 - c2;
  d := b0 * b0 - 4 * a0 * c0;
  if d < 0 then exit;                   // [g̒}CiXȂ_Ȃ
  e := sqrt(d);
  x1 := (-b0 - e) / 2 / a0;             // _x1W
  x2 := (-b0 + e) / 2 / a0;             // _x2W
  alpha := x1;
  beta  := x2;
  y1 := x1 * b2 + c2;                   // _y1W
  y2 := x2 * b2 + c2;                   // _y2W
  alpy := y1;
  bety := y2;
  if beta < alpha then begin            // l̑傫œւ  > ɂ܂AʐόvZ̈
    alpha := x2;
    beta := x1;
    alpy := y2;
    bety := y1;
  end;

  focusPoint;                           // ɂœ_ʒǔvZ

  memo1.Lines.Add(' x,y = ' + floatTostr(alpha) + ', ' + floatTostr(alpy));
  memo1.Lines.Add(' x,y = ' + floatTostr(beta) + ', ' + floatTostr(bety));
  b3 := 2 * a1 * alpha + b1;                // y1=m1x+c1 m1̒l
  c3 := - b3 * alpha + alpy;                // y1=m1x+c1 c1̒l
  b4 := 2 * a1 * beta + b1;                 // y2=m2x+c2 m2̒l
  c4 := - b4 * beta + bety;                 // y2=m2x+c2 c2̒l
  if b3 <> b4 then                          // ̒̌Xɍ_
    xcc := (c4 - c3) / (b3 - b4)            // y1=m1x+c1  y2=m2x+c2@̌_x̒l
  else xcc := 0;                            // _
  ycc := b3 * xcc + c3;                     // y1=m1x+c1  y2=m2x+c2@̌_y̒l
  memo1.Lines.Add('C x,y = ' + floatTostr(xcc) + ', ' + floatTostr(ycc));
  if not calc_arc then exit;
  result := true;
  s := abs(a1) * (beta - alpha)  * (beta - alpha) * (beta - alpha) / 6;   // |`ʐόvZ 1/6
  memo1.Lines.Add('|`ʐ   = ' + floatTostr(s));
  if (b3 = b4) then exit;

  division;                                 // ʐρ@ʂ̒xvZ

  if a1 > 0 then begin
    if yc0 > ycc then ycp := ycc - (yc0 - ycc) / 2  // y̕`͈
                 else ycp := yc0 - 0.1 / a1;
  end
  else begin
    if yc0 < ycc then ycp := ycc + (ycc - yc0) / 2  // a1x^2a1̕}ŕύX
                 else ycp := yc0 - 0.1 / a1;
  end;
  n := 1000;
  Xmin := x1 - (x2 - X1) / 4;
  Xmax := x2 + (X2 - X1) / 4;
  dx := (Xmax - Xmin) / n;
  for i := 0 to n do begin                // ڐ1̕`
    x := i * dx + Xmin;
    y := b3 * x + c3;
    if a1 > 0 then if y > ycp then Series3.AddXY(x,y);
    if a1 < 0 then if y < ycp then Series3.AddXY(x,y);
  end;
  for i := 0 to n do begin                // ڐ2̕`
    x := i * dx + Xmin;
    y := b4 * x + c4;
    if a1 > 0 then if y > ycp then Series4.AddXY(x,y);
    if a1 < 0 then if y < ycp then Series4.AddXY(x,y);
  end;
end;

// x, y ƌ̌_
// ql   ̊px
// qs   ڐ̊px
// xl x1,y1 x2,y2 ̋
// ̏I[W
procedure TForm1.fpoint(x, y, ql, qs, xl : double; var xf, yf: double);
var
  qm, qb    : double;   // qs[ɂꍇ̔ˊpqm  ߂pqb
  x1, y1, l : double;
  x2, y2    : double;
  dx, dy    : double;
begin
//  memo1.Lines.Add('px ' + floatTostr(ql / pi * 180));
//  memo1.Lines.Add('ڐpx ' + floatTostr(qs / pi * 180));
  qm := (qs - ql);                                            // ڐɑ΂pxvZ
  if qm < pi then qm := qm + pi;
//  memo1.Lines.Add('ˊpx ' + floatTostr(qm / pi * 180));
  x1 := cos(qm) * xl;                                         // [_xʒuvZ
  y1 := sin(qm) * xl;                                         // [_yʒuvZ
  l  := sqrt(x1 * x1 + y1 * y1);                              // WϊpvZ
  qb := qm + qs;                                              // ڐ̊pxɖ߂
//  memo1.Lines.Add(']px ' + floatTostr(qb / pi * 180));
  x2 := cos(qb) * l;                                          // ڐ̊pxɖ߂xW
  y2 := sin(qb) * l;                                          // ڐ̊pxɖ߂yW
  if ql * a1 > 0 then begin                 // ̊px{ x,yWlZ
    xf := x + x2;
    yf := y + y2;
  end
  else begin                                // ̊px| x,yWlZ
    xf := x - x2;
    yf := y - y2;
  end;
  // [WOtOɂȂ̂h~܂
  dy := yf - y;
  dx := xf - x;
  if yf > Chart1.LeftAxis.Maximum then begin
    yf := Chart1.LeftAxis.Maximum;
    xf := dx * ((Chart1.LeftAxis.Maximum - y) / dy) + x;
  end;
  if yf < Chart1.LeftAxis.Minimum then begin
    yf := Chart1.LeftAxis.Minimum;
    xf := dx * ((Chart1.LeftAxis.Minimum - y) / dy) + x;
  end;
  if xf < Chart1.BottomAxis.Minimum then begin
    xf := Chart1.BottomAxis.Minimum;
    yf := dy * ((Chart1.BottomAxis.Minimum - x) / dx) + y;
  end;
  if xf > Chart1.BottomAxis.Maximum then begin
    xf := Chart1.BottomAxis.Maximum;
    yf := dy * ((Chart1.BottomAxis.Maximum - x) / dx) + y;
  end;
end;

// ɂœ_ʒǔvZ
procedure TForm1.focusPoint;
var
  x, y, m   : double;
  xo        : double;                // _x
//  yo        : double;                // _y
  q, qp, mq : double;
  mfc       : double;
begin
  xo := - b1 / a1 / 2;
//  yo := xo / 2 * b1;
//  memo1.Lines.Add('o x,y = ' + floatTostr(xo) + ', ' + floatTostr(yo));
  x := xo + 2;
  y := a1 * x * x + b1 * x + c1;                    // X=1̕y̒l
  m := 2 * a1 * x + b1;                             // ڐy=mx+c m
  q := arctan(m);                                   // ڐ̊px
  qp := 2 *  q + pi / 2;                            // ˊp
  mq := tan(qp);                                    // ˌX

  mfc := -mq * x + y;                               // ˌ y := mqx + mfc mfc
  focusY := xo * mq + mfc;                          // Sʒu ʉߓ_ œ_ʒu
end;

// ƒ̕`
// }
procedure TForm1.graphDraw;
label
  IMG;
var
  i, n        : integer;
  dx, dx2     : double;
  Xmax, Xmin  : double;
  Ymax, Ymin  : double;
  Hmax, Hmin  : double;
  Vmax, Vmin  : double;
  L, ls       : double;
  x, y        : double;

  x3, y3      : double;
  x4, y4      : double;
  x0m, y0m    : double;
  x1m, y1m    : double;
  Vx, Vy      : double;
  ypl, ypm    : integer;
  xpl, xpm    : integer;
  ax, ay      : double;
  ysp, ypp    : integer;
  xsp, xpp    : integer;
  fys         : integer;
  ma, mc      : double;
  b0, c0      : double;
  d, e        : double;
  b3, c3      : double;
  Q1, Q4, Q5  : double;
  Q2          : double;
  mf, mfc     : double;
  yback       : double;
  xl          : double;
  foc         : double;
begin
  if ImgF then goto IMG;
  focusL := 1 / 4 / a1;                          // œ_vZ
  // ƌ钼̕`
  n := 1000;
  Xmin := x1 - (x2 - x1) / 4;         // `͈
  Xmax := x2 + (x2 - x1) / 4;
  if (Xmax - Xmin) = 0 then begin     // ڐƂȂƂ̕`͈
    Xmin := x1 - abs(1 / a1);
    Xmax := x1 + abs(1 / a1);
    CF := False;
  end;
  if CF then begin                   // _
    dx := abs(Xmax - Xmin) / 10;
    if a1 > 0 then begin
      if Xmin + dx > xc0 then Xmin := xc0 - dx;
      if Xmax - dx < xc0 then Xmax := xc0 + dx;
    end
    else begin
      if Xmax + dx > xc0 Then Xmax := xc0 - dx;
      if Xmin - dx < xc0 then Xmin := xc0 + dx;
    end;
  end;
  dx := abs(Xmax - Xmin) / n;
  if Xmax < Xmin then Xmin := Xmax;

  for i := 0 to n do begin
    x := i * dx + Xmin;
    y := x * x * a1 + x * b1 + c1;      // 
    Series1.AddXY(x, y);                // ̃Ot
    y := x * b2 + c2;                   // 
    Series2.AddXY(x, y);                // ̃Ot
  end;
  if CF then begin                   // _
    dx := (x2 - x1) / n;
    for i := 0 to n do begin
      x := i * dx + x1;
      y := x * x * a1 + x * b1 + c1;    // 
      Series6.AddXY(x, y);              // x1,x2Ԃ̃Ot
    end;
  end;

  Chart1.Update;
  application.ProcessMessages;          // `҂
  // Chart̏c𓯂ɐݒ肵܂
  Hmax := Chart1.BottomAxis.Maximum;
  Hmin := Chart1.BottomAxis.Minimum;
  Vmax := Chart1.LeftAxis.Maximum;
  Vmin := Chart1.LeftAxis.Minimum;
  if (focusy * 0.95) > Chart1.LeftAxis.Maximum then begin
    Vmax := focusy / 0.95;
    if (90 > Q0) and (Q0 > 0) then Vmax := Vmax + focusL / 1.5;
  end;
  if (focusy * 0.95) < Chart1.LeftAxis.Minimum then begin
    Vmin := focusy / 0.95;
    if (0 > Q0) and (Q0 > -90) then Vmin := Vmin + focusL / 1.5;
  end;
  if (Hmax - Hmin) > (Vmax - Vmin) then begin
    dx2 := ((Hmax - Hmin) - (Vmax - Vmin)) / 2;
    Vmax := Vmax + dx2;
    Vmin := Vmin - dx2;
  end
  else begin
    dx2 := ((Vmax - Vmin) - (Hmax - Hmin)) / 2;
    Hmax := Hmax + dx2;
    Hmin := Hmin - dx2;
  end;
  Series5.AddXY(Hmin, Vmax);            // Hmax,Hmin,Vmax,Vmin fׂ̈ Series
  Series5.AddXY(Hmin, Vmin);
  Series5.AddXY(Hmax, Vmin);
  Chart1.Update;
  application.ProcessMessages;          // `҂

  if not CF then exit;                  // _ȂvZ
  scrollbar2.Enabled := True;;
  scrollbar1.Enabled := True;
IMG:
  if STF then begin                     // Button1ɂvZJntO
    foc := 0;                           // ˊp90ˌ␳[
    sclpos := 1;                        // ˌ␳XP[P
  end
  else foc := focusL;                   // ˊp90ˌ␳œ_ɐݒ
  STF := False;                         // Button1ɂvZJntO
  ypl := chart1.LeftAxis.IStartPos;     // yX^[gW
  ypm := chart1.LeftAxis.IEndPos;       // yGhW
  xpl := chart1.BottomAxis.IStartPos;   // xX^[gW
  xpm := chart1.BottomAxis.IEndPos;     // xGhW
  Hmax := chart1.BottomAxis.Maximum;
  Hmin := chart1.BottomAxis.Minimum;
  Vmax := chart1.LeftAxis.Maximum;
  Vmin := chart1.LeftAxis.Minimum;
  ax := (xpm - xpl) / (Hmax - Hmin);    // xWϊW
  ay := (ypm - ypl) / (Vmax - Vmin);    // yWϊW
  xsp := round((x2 - Hmin) * ax) + xpl; // ݒׂ̈̌vZ
  ysp := round((x1 - Hmin) * ax) + xpl;
  n := abs(xsp - ysp) div 21;           // 
  if n < 5 then n := 5;
  dx := (x2 - x1) / n;
  Q5 := Q0 / 180 * pi;                  // ̊pxdeg
  yback := 0;                           // œ_yʒuNA
  for i := 0 to n do begin                            // E֌vZ
    x :=   i * dx + x1;                                 // x̒l             x
    xsp := round((x - Hmin) * ax) + xpl;
    y := x * b2 + c2;                                   // y̒l         y
    if Q0 <> 90 then begin                              // 90łȂ
      ma := tan(Q5);                                      // ̌X
      mc := y - ma * x;                                   // X ma̒ y = max + mc
      b0 := b1 - ma;                                      // ƌ̌_vZ
      c0 := c1 - mc;
      d :=  b0 * b0 - 4 * a1 * c0;
      e := sqrt(d);

      if Q5 > 0 then x3 := (-b0 - e) / 2 / a1             // _x̒l     x3
                else x3 := (-b0 + e) / 2 / a1;
      y3 := x3 * x3 * a1 + x3 * b1 + c1;                  // _y̒l     y3
      // ̓ˈʒuOt̒[_ɕύX
      if a1 > 0 then Vy := Vmax
                else Vy := Vmin;
      x0m := (Vy - mc) / ma;
      y0m := Vy;
      if ma > 0 then begin
        if a1 > 0 then Vx := Hmax
                  else Vx := Hmin;
      end
      else begin
        if a1 > 0 then Vx := Hmin
                  else Vx := Hmax;
      end;
      y1m := ma * Vx + mc;
      x1m := Vx;
      if a1 > 0 then begin
        if y0m > y1m then begin
          y0m := y1m;
          x0m := x1m;
        end;
      end
      else begin
        if y0m < y1m then begin
          y0m := y1m;
          x0m := x1m;
        end;
      end;
      xsp := round((x0m - Hmin) * ax) + xpl;              // ˌ[_x̍W
      ysp := round((Vmax - y0m) * ay) + ypl;              // ˌ[_y̍W
    end
    else begin                                          // 90̎
      X3 := x;                                            // x̒l
      y3 := x3 * x3 * a1 + x3 * b1 + c1;                  // y̒l     y3
      ysp := ypl;                                         // y̍W
      if a1 < 0 then ysp := round((Vmax - Vmin) * ay) + ypl;
    end;
    ypp := round((Vmax - y3) * ay) + ypl;               // y̍W
    xpp := round((x3 - Hmin) * ax) + xpl;               // x̍W

    Image1.Canvas.Pen.Color := clSkyblue;
    Image1.Canvas.MoveTo(xsp, ysp);                     // xʒu
    Image1.Canvas.LineTo(xpp, ypp);                     // ẍʒu֐`

    b3 := 2 * a1 * x3 + b1;                             // ڐy1=m1x+c1 m1̒l  b3
    c3 := - b3 * x3 + y3;                               // ڐy1=m1x+c1 c1̒l  c3

    if Q0 <> 90 then begin                            // px90ȊO
      xl := sqrt((x3 - xc0) * (x3 - xc0) + (y3 - focusY) * (y3 - focusY));  // ˌ
      xl := (xl + abs(focusL)) * sclpos;                // ˌ␳
      Q1 := arctan(b3);                                 // ˓_̕Ƃ̐ڐ̊pxrad
      fpoint(x3, y3, Q5, Q1, xl, x4, y4);               // ˌ̒[_ʒu߂Tu[`
      xsp := round((x4 - Hmin) * ax) + xpl;             // [_ʒux̍W
      ysp := round((Vmax - y4) * ay) + ypl;             // [_ʒuy̍W
    end
    else begin                                        // 90̎
      Q2 := arctan(b3) / pi * 180;                      // ˓_̕Ƃ̐ڐ̊pxdeg
//      Q2 := 90 + Q1;
//      Q3 := 90 - Q2;
//      Q4 := Q2 - Q3;
      Q4 := 90 + 2 * Q2;                                // ˊpdeg
      if Q4 <> 90 then begin                            // ˊp90ȊO
        mf := tan(Q4 / 180 * pi);                         // ̌Xprad
        mfc := -mf * x3 + y3;                             //  y = mfX + mfc
        x4 := xc0;                                        // _x
        y4 := X4 * mf + mfc;                              // _x̔ˌyl
        yback := y4;                                      // yl̃obNAbv
        Q1 := arctan(b3);                                 // ˓_̕Ƃ̐ڐ̊pxrad
        xl := sqrt((x3 - x4) * (x3 - x4) + (y3 - y4) * (y3 - y4));  // ˌ
        xl := (xl + abs(foc)) * sclpos;                   // ˌ␳
        fpoint(x3, y3, Q5, Q1, xl, x4, y4);               // ˌ̒[_ʒu߂Tu[`

        xsp := round((x4 - Hmin) * ax) + xpl;             // œ_ʒux̍W
        ysp := round((Vmax - y4) * ay) + ypl;             // œ_ʒuyW
      end
      else begin                                        // ˊp90̎
        xsp := round((x - Hmin) * ax) + xpl;              // œ_ʒuxW
        if yback = 0 then y4 := abs(y3 + focusL + foc) * sclpos   // ˌ
                     else y4 := (yback + foc) * sclpos;
        if y4 > Vmax then y4 := Vmax;
        if y4 < Vmin then y4 := Vmin;
        ysp := round((Vmax - y4) * ay) + ypl;             // ˌ[_ʒuyW
      end;
    end;
    Image1.Canvas.Pen.Color := clPurple;                  // ˌ
    Image1.Canvas.MoveTo(xsp, ysp);                       // [_xyW
    Image1.Canvas.LineTo(xpp, ypp);                       // _W
  end;
  if not ImgF then begin
    memo1.Lines.Add('');
    if abs(Q0) = 90 then begin
      memo1.Lines.Add('œ_x, yW = ' + floatTostrF(xc0, ffFixed, 13, 8) + ', '
                                                      + floatTostrF(yback, ffFixed, 13, 8))
    end
    else begin
      memo1.Lines.Add('œ_x, yW = ' + floatTostrF(xc0, ffFixed, 13, 8) + ', '
                                                      + floatTostrF(focusY, ffFixed, 13, 8));
      memo1.Lines.Add('œ_W gU');
    end;
    memo1.Lines.Add('œ_ = ' + floatTostrF(focusL, ffFixed, 13, 8));
  end;

  // ̕` ,,c,o@
  fys := 12;
  Image1.Canvas.Font.Size := fys;
  Image1.Canvas.Font.Color := clRed;
  Image1.Canvas.TextOut(xpl + 10, ypl, 'px = ' + floatTostr(Q0) + '');
  Image1.Canvas.Font.Color := clBlack;
  Image1.Canvas.Font.Size := fys;
  xsp := round((beta - Hmin) * ax) + xpl + 10;
  ysp := round((Vmax - bety) * ay) + ypl - fys;
  Image1.Canvas.TextOut(xsp,ysp,'');                  // ƕ̍W
  xsp := round((alpha - Hmin) * ax) + xpl - 22;
  ysp := round((Vmax - alpy) * ay) + ypl - fys;
  Image1.Canvas.TextOut(xsp,ysp,'');                  // ƕ̍W

  xsp := round((xcc - Hmin) * ax) + xpl - 22;
  ysp := round((Vmax - ycc) * ay) + ypl - fys;
  Image1.Canvas.TextOut(xsp,ysp,'c');                   // ڐ̌_Wc

  xsp := round((xc0 - Hmin) * ax) + xpl - 8;
  if a1 > 0 then fys := 0;
  ysp := round((Vmax - yc0) * ay) + ypl - fys * 2;
  Image1.Canvas.TextOut(xsp,ysp,'o');                   // _̍Wo
  Image1.Canvas.Font.Size := 9;
  Image1.Canvas.Font.Color := clBlue;
end;

// Image摜
procedure TForm1.ImageClear;
begin
  Image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.FillRect(rect(0, 0, Image1.Width, Image1.Height));
  Image1.Canvas.Brush.Style := bsClear;
  Chart1.BackImage.Bitmap := Image1.Picture.Bitmap;
end;

// vZJn
procedure TForm1.Button1Click(Sender: TObject);
begin
  Button1.Enabled := False;
  scrollbar1.Enabled := False;
  scrollbar2.Enabled := False;
  ImageClear;                       // Image摜
  memo1.Clear;
  Series1.Clear;                    // 
  Series2.Clear;                    // ɑ΂钼
  Series3.Clear;                    // ڐ
  Series4.Clear;                    // ڐ
  Series5.Clear;                    // XyXP[ݒ
  Series6.Clear;                    // ˖
  if not datainput then begin
    Button1.Enabled := True;
    exit;
  end;
  CF := True;                       // vZtO
  sclpos := scrollbar1.Position / 50;
  if not calc_point_of_intersection then begin
    Memo1.Lines.Add('_');
    CF := False;                    // _tO vZ
    x1 := b1 / 2 - abs(1 / a1);     // _Ȃ̍}͈͐ݒ
    x2 := b1 / 2 + abs(1 / a1);
  end;
  ImgF := False;                    // Seriesf[^[tO
  graphDraw;                        // }
  Chart1.BackImage.Bitmap := Image1.Picture.Bitmap;
  Button1.Enabled := True;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  bm : Tbitmap;
begin
  SCF := False;                     // ˌ̒LtO
  scrollbar1.Enabled := False;      // ˌ̒XN[o[
  scrollbar2.Enabled := False;;     // ˌpxXN[o[
  bm := Tbitmap.Create;
  bm.Width := Chart1.Width;
  bm.Height := Chart1.Height;
  Image1.Width := Chart1.Width;
  Image1.Height := Chart1.Height;
  Image1.Picture.Bitmap := bm;
  Image1.Canvas.Brush.Color := clWhite;
  Image1.Visible := False;
  bm.Free;
  Label5.Caption :=
          'ʂł̔˂͈x̔ˌvZłB' + #13#10 +
          '˖ʂ̊pxɋ߂pxœƕ񔽎˂鎖܂B' + #13#10 +
          '̔˂͍lĂ܂B';
  Label6.Caption := 'px́AvZAvZp̊pxɕϊ܂B';
end;

// ˌ
procedure TForm1.ScrollBar1Scroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
  ImageClear;                         // Image摜
  ImgF := True;                       // Image摜̂ݍ}tO
  sclpos := scrollbar1.Position / 50; // ˌݒW
  graphDraw;
  Chart1.BackImage.Bitmap := Image1.Picture.Bitmap;
end;

// ˌpx
procedure TForm1.ScrollBar2Scroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
  if not CF then exit;
  Q0 := ScrollPos;
  if Q0 <= 0 then exit;
  if Q0 >= 180 then exit;
  if not SCF then exit;               // ˌ̒LtO
  if a1 < 0 then Q0 := - Q0;
  if a1 > 0 then begin
    if Q0 >   90 then Q0 := Q0 - 180;
  end
  else begin
    if Q0 <= -90 then Q0 := 180 + Q0;
  end;
  ImgF := True;                       // Image摜̂ݍ}tO
  ImageClear;                         // Image摜
  graphDraw;
  Chart1.BackImage.Bitmap := Image1.Picture.Bitmap;
end;

procedure TForm1.LabeledEdit1Change(Sender: TObject);
begin
  ScrollBar2.Enabled := False;
  SCF := False;                       // ˌ̒LtO
end;

procedure TForm1.LabeledEdit4Change(Sender: TObject);
begin
  ScrollBar2.Enabled := False;
  SCF := False;                       // ˌ̒LtO
end;

end.
